/*
 * Description:	StarOffice linguistic checker general header definitions
 *
 * I get this informations from the StarOffice help and hope it's all right!? 
 *
 *	2000 by Michael Schroeder <mdhs@gmx.net>
 */

#ifndef SOLING_H
# define SOLING_H

#if defined (__cplusplus)
extern "C" {
#endif

#ifdef __WINDOWS__
# define CALLTYPE	__stdcall
#else
# define CALLTYPE
#endif

/*
 * exported capabilities 
 */ 
#define SO_spelling	0x0001 
#define SO_thesaurus	0x0002 
#define SO_hyphenation	0x0004 
#define SO_optiondlg	0x0008 

/*
 * truth value
 */
#define SO_false	0
#define SO_true		1


/*
 * expected function prototypes, called by StarOffice
 */
/* general */
short CALLTYPE Get_version(void);			/* return always SO_true */
char CALLTYPE Available(void);				/* get module capabilities */
char CALLTYPE OptionDlg(void *ParentWindowHandle);	/* linux: null pointer */
char CALLTYPE SetLanguage(short nLanguage);		/* see xlang.h (SO Mistake: same name but different prototype in addin.h - that's incorrect; should be Set_Language) */
short CALLTYPE FreeAlloc(void);				/* badly documented */

/* spell checker */
char CALLTYPE SpellQuick(char *Word);			/* only check word */
char CALLTYPE SpellWord(char *Word, char **Suggestions); /* return suggestion list */
char CALLTYPE AddWord(char *Word);			/* add word to private dict */

/* thesaurus */
char CALLTYPE LookUp(char *Word,  char **Suggestions);	/* return list of suggestions */
char CALLTYPE Synonyme(short pos,  char **Synonyms);	/* return list of synonyms */

/* hyphenation */
unsigned short CALLTYPE LastHyph(char *Word, short MinHeader, short MinTrailer,
                        char **NewWord);	/* return changed word */
char CALLTYPE AllHyph(short *Word, short MinHeader, short MinTrailer,
             char **HyphWord);			/* return all posibilities */


#if defined (__cplusplus)
}
#endif

#endif		/* SOLING_H */